library ieee;
use ieee.std_logic_1164.all;

entity BinTo7Seg is
	port (a3, a2, a1, a0: in std_logic; a, b, c, d, e, f, g: out std_logic);
end entity BinTo7Seg;

architecture BinDecode of BinTo7Seg is
begin
	a <= (a0 and a2)
		 or (not a0 and not a2)
		 or (a1 and not a3)
		 or (not a1 and a3);
	
	b <= (a0 and a1 and not a3)
	 	 or (not a0 and not a1)
		 or (not a0 and a3)
		 or (not a1 and a3)
		 or (not a2);
	
	c <= (a0)
		 or (a1 and a2)
		 or (not a1 and not a3)
		 or (not a2 and a3);
	
	d <= (a0 and not a1 and a2)
		 or (a0 and a2 and a3)
		 or (not a0 and a1 and not a3)
		 or (not a0 and not a2)
		 or (a1 and not a2 and not a3)
		 or (not a1 and a2 and a3);
	
	e <= (not a0 and a1 and not a3)
		 or (not a0 and not a1 and a3)
		 or (not a0 and not a2);
	
	f <= (not a0 and a1 and a2)
		 or (not a0 and a1 and a3)
		 or (not a0 and not a1 and not a3)
		 or (a1 and a2 and a3)
		 or (not a1 and a2 and not a3)
		 or (not a1 and not a2 and a3);
	
	g <= (not a0 and a1 and not a3)
		 or (a1 and not a2 and not a3)
		 or (not a1 and a2)
		 or (not a1 and a3)
		 or (a2 and a3);

end architecture BinDecode;